#pragma once

#include "LibNGAP_TypesAndValues.hh"
#include "ngap_pdu_codec.hh"
//#include "codec.hh"
#include "NGAP_PDU_Descriptions.hh"

class BITSTRING;   //! Forward declaration of TITAN class
class OCTETSTRING; //! Forward declaration of TITAN class
//class params_;

class Base_Type;
class TTCN_Typedescriptor_t;
class TTCN_Buffer;


//namespace NGAP__PDU__Descriptions { //! Forward declaration of asn1c NGAP class
//  class NGAP__PDU;
//}

//class ngap_codec : public codec<NGAP__PDU__Descriptions::NGAP__PDU, NGAP__PDU__Descriptions::NGAP__PDU> {
class ngap_codec {
  ngap_pdu_codec asn_codec;

  int encode_(const Base_Type &type, const TTCN_Typedescriptor_t &field_descriptor, TTCN_Buffer &encoding_buffer);

  int decode_(Base_Type &type, const TTCN_Typedescriptor_t &field_descriptor, TTCN_Buffer &decoding_buffer);


public:
  //explicit ngap_codec() : codec<NGAP__PDU__Descriptions::NGAP__PDU, NGAP__PDU__Descriptions::NGAP__PDU>(), asn_codec(){};
  /*explicit*/ ngap_codec() :  asn_codec(){};
  virtual ~ngap_codec(){};

  /*virtual*/ int encode(const NGAP__PDU__Descriptions::NGAP__PDU& ngap, OCTETSTRING &data);
  /*virtual*/ int decode(const OCTETSTRING &data, NGAP__PDU__Descriptions::NGAP__PDU &, params *params = NULL);
};

//void NGAP__PDU::encode(const TTCN_Typedescriptor_t& p_td, TTCN_Buffer& p_buf, int p_coding, ...) const
//{
//  va_list pvar;
//  va_start(pvar, p_coding);
 // switch(p_coding) {
//  case TTCN_EncDec::CT_BER: {

